Skip to main content

Device Recipes Actions

https://api.losant.com/applications/APPLICATION_ID/device-recipes

Below are the various requests that can be performed against the Device Recipes resource, as well as the expected parameters and the potential responses.

Get​

Returns the device recipes for an application

Method And Url​

GET https://api.losant.com/applications/APPLICATION_ID/device-recipes

Authentication​

A valid API access token is required to access this endpoint. The token must include at least one of the following scopes: all.Application, all.Application.bounded, all.Application.read, all.Organization, all.Organization.bounded, all.Organization.read, all.User, all.User.bounded, all.User.read, deviceRecipes.*, or deviceRecipes.get.

Request Path Components​

Path ComponentDescriptionExample
APPLICATION_IDID associated with the application575ec8687ae143cd83dc4a97

Request Query Parameters​

NameRequiredDescriptionDefaultExample
sortFieldNField to sort the results by. Accepted values are: name, id, creationDate, lastUpdatednamesortField=name
sortDirectionNDirection to sort the results by. Accepted values are: asc, descascsortDirection=asc
pageNWhich page of results to return0page=0
perPageNHow many items to return per page100perPage=10
filterFieldNField to filter the results by. Blank or not provided means no filtering. Accepted values are: namefilterField=name
filterNFilter to apply against the filtered field. Supports globbing. Blank or not provided means no filtering.filter=my * recipe
tagsAsObjectNReturn tags as an object map instead of an arraytagsAsObject=false
attributesAsObjectNReturn attributes as an object map instead of an arrayattributesAsObject=true

Request Headers​

NameRequiredDescriptionDefault
AuthorizationYThe token for authenticating the request, prepended with Bearer

Curl Example​

curl -H 'Content-Type: application/json' \
-H 'Accept: application/json' \
-H 'Authorization: Bearer YOUR_API_ACCESS_TOKEN' \
-X GET \
https://api.losant.com/applications/APPLICATION_ID/device-recipes

Successful Responses​

CodeTypeDescription
200Device RecipesCollection of device recipes

Error Responses​

CodeTypeDescription
400ErrorError if malformed request
404ErrorError if application was not found

Post​

Create a new device recipe for an application

Method And Url​

POST https://api.losant.com/applications/APPLICATION_ID/device-recipes

Authentication​

A valid API access token is required to access this endpoint. The token must include at least one of the following scopes: all.Application, all.Application.bounded, all.Organization, all.Organization.bounded, all.User, all.User.bounded, deviceRecipes.*, or deviceRecipes.post.

Request Path Components​

Path ComponentDescriptionExample
APPLICATION_IDID associated with the application575ec8687ae143cd83dc4a97

Request Query Parameters​

NameRequiredDescriptionDefaultExample
tagsAsObjectNReturn tags as an object map instead of an arraytagsAsObject=false
attributesAsObjectNReturn attributes as an object map instead of an arrayattributesAsObject=true

Request Headers​

NameRequiredDescriptionDefault
AuthorizationYThe token for authenticating the request, prepended with Bearer

Request Body​

The body of the request should be serialized JSON that validates against the Device Recipe Post schema. For example, the following would be a valid body for this request:

{
"name": "My New Device Recipe",
"deviceName": "Future device name",
"description": "Description of my new device recipe",
"deviceDescription": "Future device description",
"tags": [
{
"key": "TagKey",
"value": "TagValue"
}
],
"attributes": [
{
"name": "voltage",
"dataType": "number"
}
],
"deviceClass": "standalone"
}

Curl Example​

curl -H 'Content-Type: application/json' \
-H 'Accept: application/json' \
-H 'Authorization: Bearer YOUR_API_ACCESS_TOKEN' \
-X POST \
-d '{"name":"My New Device Recipe","deviceName":"Future device name","description":"Description of my new device recipe","deviceDescription":"Future device description","tags":[{"key":"TagKey","value":"TagValue"}],"attributes":[{"name":"voltage","dataType":"number"}],"deviceClass":"standalone"}' \
https://api.losant.com/applications/APPLICATION_ID/device-recipes

Successful Responses​

CodeTypeDescription
201Device RecipeSuccessfully created device recipe

Error Responses​

CodeTypeDescription
400ErrorError if malformed request
404ErrorError if application was not found

Schemas​

Device Recipe​

Schema for a single Device Recipe

Device Recipe Schema​

  • ▶
    {} 3 keys
    • "http://json-schema.org/draft-07/schema#"
    • "object"
    • ▶
      {} 16 keys
      • ▶
        {} 2 keys
        • ▶
          {} 2 keys
          • ▶
            {} 2 keys
            • ▶
              {} 2 keys
              • ▶
                {} 2 keys
                • ▶
                  {} 3 keys
                  • ▶
                    {} 2 keys
                    • ▶
                      {} 2 keys
                      • ▶
                        {} 2 keys
                        • ▶
                          {} 1 key
                          • ▶
                            {} 1 key
                            • ▶
                              {} 2 keys
                              • ▶
                                {} 2 keys
                                • ▶
                                  {} 1 key
                                  • ▶
                                    {} 3 keys
                                    • ▶
                                      {} 1 key

                                  Device Recipe Example​

                                  • ▶
                                    {} 12 keys
                                    • "575ecec57ae143cd83dc4a9f"
                                    • "575ecec57ae143cd83dc4a9f"
                                    • "575ec8687ae143cd83dc4a97"
                                    • "2016-06-13T04:00:00.000Z"
                                    • "2016-06-13T04:00:00.000Z"
                                    • "Actual recipe name"
                                    • "Future device name"
                                    • "My recipe description"
                                    • "Future device description"
                                    • ▶
                                      [] 1 item
                                      • ▶
                                        [] 1 item
                                        • "standalone"

                                      Device Recipe Post​

                                      Schema for the body of a Device Recipe creation request

                                      Device Recipe Post Schema​

                                      • ▶
                                        {} 5 keys
                                        • "http://json-schema.org/draft-07/schema#"
                                        • "object"
                                        • ▶
                                          {} 11 keys
                                          • ▶
                                            {} 3 keys
                                            • ▶
                                              {} 3 keys
                                              • ▶
                                                {} 2 keys
                                                • ▶
                                                  {} 2 keys
                                                  • ▶
                                                    {} 3 keys
                                                    • ▶
                                                      {} 3 keys
                                                      • ▶
                                                        {} 2 keys
                                                        • ▶
                                                          {} 2 keys
                                                          • ▶
                                                            {} 1 key
                                                            • ▶
                                                              {} 3 keys
                                                              • ▶
                                                                {} 1 key
                                                              • false
                                                              • ▶
                                                                [] 1 item

                                                              Device Recipe Post Example​

                                                              • ▶
                                                                {} 7 keys
                                                                • "My New Device Recipe"
                                                                • "Future device name"
                                                                • "Description of my new device recipe"
                                                                • "Future device description"
                                                                • ▶
                                                                  [] 1 item
                                                                  • ▶
                                                                    [] 1 item
                                                                    • "standalone"

                                                                  Device Recipes​

                                                                  Schema for a collection of Device Recipes

                                                                  Device Recipes Schema​

                                                                  • ▶
                                                                    {} 3 keys
                                                                    • "http://json-schema.org/draft-07/schema#"
                                                                    • "object"
                                                                    • ▶
                                                                      {} 10 keys
                                                                      • ▶
                                                                        {} 2 keys
                                                                        • ▶
                                                                          {} 1 key
                                                                          • ▶
                                                                            {} 1 key
                                                                            • ▶
                                                                              {} 1 key
                                                                              • ▶
                                                                                {} 1 key
                                                                                • ▶
                                                                                  {} 1 key
                                                                                  • ▶
                                                                                    {} 1 key
                                                                                    • ▶
                                                                                      {} 1 key
                                                                                      • ▶
                                                                                        {} 2 keys
                                                                                        • ▶
                                                                                          {} 2 keys

                                                                                      Device Recipes Example​

                                                                                      • ▶
                                                                                        {} 8 keys
                                                                                        • ▶
                                                                                          [] 1 item
                                                                                          • 1
                                                                                          • 4
                                                                                          • 1
                                                                                          • 0
                                                                                          • "name"
                                                                                          • "asc"
                                                                                          • "575ec8687ae143cd83dc4a97"

                                                                                        Error​

                                                                                        Schema for errors returned by the API

                                                                                        Error Schema​

                                                                                        • ▶
                                                                                          {} 3 keys
                                                                                          • "http://json-schema.org/draft-07/schema#"
                                                                                          • "object"
                                                                                          • ▶
                                                                                            {} 3 keys
                                                                                            • ▶
                                                                                              {} 1 key
                                                                                              • ▶
                                                                                                {} 1 key
                                                                                                • ▶
                                                                                                  {} 2 keys

                                                                                              Error Example​

                                                                                              • ▶
                                                                                                {} 2 keys
                                                                                                • "NotFound"
                                                                                                • "Application was not found"

                                                                                              Was this page helpful?


                                                                                              Still looking for help? You can also search the Losant Forums or submit your question there.